// naumann@stce.rwth-aachen.de

#include "newton_a.hpp"

#include <vector>

template<typename T, typename PT>
std::vector<T> gradient(T &x, const T &p, const PT &eps, const unsigned int maxit) {
  std::vector<T> g;
  T x_a=1,p_a=0;
  f_a(x,x_a,p,p_a,eps,maxit); 
  g.push_back(x_a); 
  g.push_back(p_a); 
  return g;
}

#include <iostream>
#include <cassert>

int main(int argc, char *argv[]) {
  assert(argc==5); using T=double; using namespace std;
  T x=stof(argv[1]), p=stof(argv[2]), eps=stof(argv[3]); 
  unsigned int maxit=stoi(argv[4]); assert(maxit>0);
  assert(p>0); assert(eps>0);
  vector<T> g=gradient(x,p,eps,maxit);
  cout << "x=" << x << endl;
  cout << "g= [ "; for (const auto& i:g) cout << i << " ";
  cout << "]" << endl;
  return 0;
}
