// naumann@stce.rwth-aachen.de

#include<cmath>
#include<stack>

template<typename T, typename PT>
void f_a(T &x, T &x_a, const T &p, T &p_a, const PT &eps, const unsigned int maxit) {
  std::stack<T> tbr;
  unsigned int it=0;
  T f=pow(x,2)-p;
  do {
    T dfdx=2*x;
    tbr.push(x);
    x-=f/dfdx;
    tbr.push(f);
    f=pow(x,2)-p;
    tbr.push(dfdx);
    if (++it==maxit) break;
  } while(fabs(f)>eps);
  T x_out=x;
  T f_a=0;
  for (auto i=it;i>0;--i) {
    T dfdx_a=0;
    T dfdx=tbr.top(); tbr.pop();
    f=tbr.top(); tbr.pop();
    p_a+=-f_a; x_a+=2*x*f_a; f_a=0;
    x=tbr.top(); tbr.pop();
    f_a+=-x_a/dfdx; dfdx_a+=x_a*f/pow(dfdx,2); 
    x_a+=2*dfdx_a; // dfdx_a=0;
  }
  p_a+=-f_a; x_a+=2*x*f_a; // f_a=0;
  x=x_out;
}
